/* $id$

	Create the names of global flags and the shared flags structure
	from CONTEXT.H_C.

	Useage: mkgflags <CONTEXT.H_C >GFLAGS.H_C
*/

#include <ctype.h>
#include <stdio.h>
#include <string.h>

#define isline(str)	memcmp(buf, str, sizeof(str) - 1) == 0

char buf[2048];

enum {NEED_START, PARSE_SHARED, PARSE_ANY} state = NEED_START;

main(void)
{	
	puts("/* WARNING: This is an autogenerated file */\n"
		"#include <algnbyte.h>\n"
		"typedef struct {");
	while(fgets(buf, sizeof(buf), stdin))
		switch(state) {
		case NEED_START:
			if(isline("/* START OF FLAGS */")) {
				state = PARSE_SHARED;
			}
			break;
		case PARSE_SHARED:
			if(isline("/* END OF SHARED FLAGS */")) {
				fputs(buf, stdout);
				state = PARSE_ANY;
				break;
			}
			if(*buf != '/')
				fputs(buf, stdout);
			/**FALL THROUGH**/
		case PARSE_ANY:
			if(isline("/* END OF FLAGS */"))
				goto okRet;
			if(*buf != '/') {
				unsigned char *p, *q;

				if((p = (unsigned char*)strchr(buf, ';')) == 0) {
					fprintf(stderr, "Syntax error: %s", buf);
					return 40;
				}
				*p = 0;
				while(--p >= (unsigned char*)buf && (isalnum(*p) || *p == '_'));
				if(memcmp(q = p + 1, "f_", 2) == 0)
					q += 2;
				printf("#define gflag_%s (ctxtFlagsP->%s)\n", q, p + 1);
				if(state == PARSE_SHARED)
					printf("#define lflag_%s (ctxtSharedFlags.%s)\n", q, p + 1);
			}
			break;
	}

okRet:
	puts("} ctxt_shared_flags_t;\n"
		"#include <algndflt.h>");

	return 0;
}
